Package net.sourceforge.jiu.color.data

# Interface CoOccurrenceFrequencyMatrix

All Known Implementing Classes:
  `BaseCoOccurrenceFrequencyMatrix`, `MemoryCoOccurrenceFrequencyMatrix`

public interface CoOccurrenceFrequencyMatrix
An interface for a co-occurrence frequency matrix. Also provides access to some statistical data. This class is not a pure data type for it also demands a method `computeStatistics()` which takes the matrix coefficients and computes mean, standard deviation and other properties from it.

Author:
  Marco Schmidt

## Method Summary

Modifier and Type
Method
Description
`void`
`clear()`
Sets all frequency values in this matrix to `0.0`.
`void`
`computeStatistics()`
Computes mean, standard deviation and the sum of those two so that these values can be queried by the appropriate get methods.
`int`
`getDimension()`
Returns the dimension of this matrix.
`double`
`getMean(int index)`
Returns the mean for all pairs (index, i), with i running from 0 to `getDimension()` - 1.
`double`
`getScofMean()`
Returns the sum of mean and standard deviation for all pairs (index, x), with x running from 0 to getDimension() - 1.
`double`
`getScofStddev()`
Returns the standard deviation for all pairs (i, i), with i running from 0 to getDimension() - 1.
`double`
`getScofSum()`
`double`
`getStddev(int index)`
Returns the standard deviation of the values getValue(index, i) with i running from 0 to `getDimension()` - 1.
`double`
`getValue(int i)`
Returns the value for the self co-occurrence frequency of i (i being from 0 to `getDimension()` - 1).
`double`
`getValue(int i, int j)`
`void`
`setValue(int i, int j, double newValue)`

## Method Details

### clear

void clear()
Sets all frequency values in this matrix to `0.0`.

### computeStatistics

void computeStatistics()
Computes mean, standard deviation and the sum of those two so that these values can be queried by the appropriate get methods.

### getScofMean

double getScofMean()
Returns the sum of mean and standard deviation for all pairs (index, x), with x running from 0 to getDimension() - 1. The result is equal to `getMean(int)` + `getStddev(int)`

### getMean

double getMean(int index)
Returns the mean for all pairs (index, i), with i running from 0 to `getDimension()` - 1.

### getStddev

double getStddev(int index)
Returns the standard deviation of the values getValue(index, i) with i running from 0 to `getDimension()` - 1.

Parameters:
  `index` - first argument to all calls of getValue used to determine the standard deviation

### getScofStddev

double getScofStddev()
Returns the standard deviation for all pairs (i, i), with i running from 0 to getDimension() - 1.

Returns:
  standard deviation for pairs

### getScofSum

double getScofSum()

### getDimension

int getDimension()
Returns the dimension of this matrix.

### getValue

double getValue(int i)
Returns the value for the self co-occurrence frequency of i (i being from 0 to `getDimension()` - 1). The result is the same as a call to `getValue(i, i)`.

Parameters:
  `i` - index into the matrix, must be larger than or equal to 0 and smaller than `getDimension()`

### getValue

double getValue(int i, int j)

### setValue

void setValue(int i, int j, double newValue)